Find K Pairs with Smallest Sums
Posted apanda009
tags:
篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了Find K Pairs with Smallest Sums相关的知识,希望对你有一定的参考价值。
You are given two integer arrays nums1 and nums2 sorted in ascending order and an integer k. Define a pair (u,v) which consists of one element from the first array and one element from the second array. Find the k pairs (u1,v1),(u2,v2) ...(uk,vk) with the smallest sums. Example 1: Given nums1 = [1,7,11], nums2 = [2,4,6], k = 3 Return: [1,2],[1,4],[1,6] The first 3 pairs are returned from the sequence: [1,2],[1,4],[1,6],[7,2],[7,4],[11,2],[7,6],[11,4],[11,6] Example 2: Given nums1 = [1,1,2], nums2 = [1,2,3], k = 2 Return: [1,1],[1,1] The first 2 pairs are returned from the sequence: [1,1],[1,1],[1,2],[2,1],[1,2],[2,2],[1,3],[1,3],[2,3] Example 3: Given nums1 = [1,2], nums2 = [3], k = 3 Return: [1,3],[2,3] All possible pairs are returned from the sequence: [1,3],[2,3]
类似于find kth small element in sorted matrix, 另外数组是个好东西,在构造heap 的元素的时候
Some observations: For every numbers in nums1, its best partner(yields min sum) always strats from nums2[0] since arrays are all sorted;
Frist, we take the first k elements of nums1 and paired with nums2[0] as the starting pairs so that we have (0,0), (1,0), (2,0),.....(k-1,0) in the heap.
Each time after we pick the pair with min sum, we put the new pair with the second index +1. ie, pick (0,0), we put back (0,1). Therefore, the heap alway maintains at most min(k, len(nums1)) elements.
For each pair, we need to keep track of its position in nums2[], if the position is greater than or equal to nums2‘s size, no need to put back new pair with second index+1
Below is also a good way to define heap
PriorityQueue<int[]> queue = new PriorityQueue<>((a,b)->a[0]+a[1]-b[0]-b[1]);
public class Solution { public List<int[]> kSmallestPairs(int[] nums1, int[] nums2, int k) { PriorityQueue<int[]> queue = new PriorityQueue<int[]>(k, new Comparator<int[]>() { public int compare(int[] a, int[] b) { return (a[0]+a[1])-(b[0]+b[1]); } }); //PriorityQueue<int[]> queue = new PriorityQueue<>((a,b)->a[0]+a[1]-b[0]-b[1]); List<int[]> res = new ArrayList<int[]>(); if (nums1.length==0 || nums2.length==0 || k==0) return res; for (int i=0; i<nums1.length && i<k; i++) { queue.offer(new int[]{nums1[i], nums2[0], 0}); } for (int i=0; i<k && !queue.isEmpty(); i++) { int[] cur = queue.poll(); res.add(new int[]{cur[0], cur[1]}); if (cur[2]+1 < nums2.length) { queue.offer(new int[]{cur[0], nums2[cur[2]+1], cur[2]+1}); } } return res; } }
以上是关于Find K Pairs with Smallest Sums的主要内容,如果未能解决你的问题,请参考以下文章
#Leetcode# 373. Find K Pairs with Smallest Sums
373. Find K Pairs with Smallest Sums
Find K Pairs with Smallest Sums
373. Find K Pairs with Smallest Sums